{
  -- Antoun Kanawati.
  -- June 20, 1990.
  -- Software reboot of a Turbo-XT 3.01 BIOS machine.
}
program reboot_machine;
  uses
    inputil; {-- Provides some I/O interface --}

  { The memw[] access does not seem to make a difference on }
  { Turbo-XT 3.01 bios.                                     }
  { Int 19 --> warm boot (with a major chance of hanging).  }
  { jumping to ffff:0000 is a cold boot always. The first   }
  {   instruction set executed at that location always sets }
  {   memw[40:72] to zero.                                  }
  { Slowing the CPU down does not help either.		    }
  {                                                         }
  { The following procedure helps:                          }
  { According to the debugger, the code at ffff:0000, is    }
  { a jump to f000:e05b.  At that location, the first few   }
  { instructions set 0040:0072 to zero, and proceed to      }
  { f000:e066.                                              }
  { So, I tried jumping straight to f000:e066,  with the    }
  { different values of the word at 0040:0072, and things   }
  { worked out.  The following code illustrates.            }

  procedure reboot(warm : boolean);
    begin
      if (warm) then
        memw[$40:$72] := $1234
      else
        memw[$40:$72] := 0;

      { set CPU mode to slow }
      {inline($e4/$61/$24/$fb/$e6/$61);}
      { in  al, 61h  }
      { and al, 0fbh }
      { out 61h, al  }

      inline($EA/$66/$E0/$00/$F0) { jmp f000:e066 }
    end;

  begin
    reboot(say_yes('Warm reboot ? '))
  end.
